function OnInit()

	this:SetVisualProfile("~/x-armor.xml", "x-armor");
	this:LoadCollisionInfo("~/x-armor.col");
end

function OnPostInit()
	
	this:GetBrainManager():Add("StandardBase","");
	this:GetBrainManager():SendToBrainBase("control_filtery=0");
	this:SetCategory(C_CATEGORY_ENEMY, true);
	this:SetCategory(C_CATEGORY_ENTITY, false);
	this:SetCollisionListenCategory(C_CATEGORY_PLAYER, true);
	this:SetCollisionCategory(C_CATEGORY_PLAYER, true);
	this:SetTurnSpeed(10);
	this:SetIsCreature(true);
	this:SetVisibilityNotifications(true);
	this:SetDensity(1);
	
	
	m_hp = 20;
	
	
end

function SetParent(parent, xfacing)

	m_parent = parent;
	this:SetFacingTarget(xfacing);
	
end

function OnGetVisible()

	Schedule(800, this:GetID(), "Think()");

end

function OnLoseVisible()

 
end

function Think()

	if (m_hp <= 0) then
		return;
	end
	
	if (this:IsCloseToEntity(GetPlayer, 400)) then
	
		this:GetBrainManager():SetStateByName("Attack");
		Schedule(500, this:GetID(), 'ent = CreateEntity(this:GetMap(), this:GetPos() + (FacingToVector(this:GetFacing()) * 64 + Vector2(0,-64)), "enemies/armor/flyingaxe.lua"); ent:RunFunction("SetParent", this);');
		
	else
	
		Schedule(500+random(300), this:GetID(), "Think()");
	
	end	

end

function OnAttackLoop()

	this:GetBrainManager():SetStateByName("Idle");
	Schedule(500+random(200), this:GetID(), "Think()");
	
end

function OnAction(enemy)

	GetTextManager:Add("It's an empty suit of armor.", enemy);
   
end

function OnDamage(normal, depth, enemy, damage, userVar, projectile)

	pushVec = this:GetPos() - enemy:GetPos();
	pushVec:Normalize();

	this:AddForce(pushVec * 5);
	
	 if (m_hp <= 0) then
	 	--//already dead
	 	return;
 	end

	m_hp = m_hp - damage;
	GetTextManager:AddCustom(tostring(damage), this, this:GetPos(), Vector2(0, -0.3), Color(200,0,0,255), 2000, C_FONT_DEFAULT);
	this:GetBrainManager():Add("ColorFlash", "pulse_rate=200;g=-200;b=-200;remove_brain_by_pulses=1");
 
	if (m_hp <= 0) then
  --//kill it
	  	this:GetBrainManager():SetStateByName("Die");
	  	GetSoundManager:Play("audio/bug_die.ogg");
	  	Schedule(500, this:GetID(), "this:GetBrainManager():Add('FadeOutAndDelete','');");
	  	this:SetDensity(0.2);
		itemdrop = CreateEntity(this:GetMap(), this:GetPos()+Vector2(0,-32), "items/coin/coin.lua");
		this:SetCollisionCategory(C_CATEGORY_PLAYER, false);
		this:SetLayerID(this:GetLayerID()-1);
		m_parent:Data():Set("HasSpawned", "false");
	else
		GetSoundManager:Play("audio/bug_attack.ogg");
	end

end

function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	 if (m_hp > 0) then
	 	entity:RunFunctionIfExists("OnDamage", vNormal, depth, entity, 5, 0, nil);  	
	 end
  
return;
end

