function OnInit()	
	this:SetVisualProfile("~/bat.xml", "bat");
	this:LoadCollisionInfo("~/bat.col");
	this:SetDesiredSpeed(8);
	this:SetTurnSpeed(10);
	m_parent = nil;
end

function OnPostInit()	
	this:SetGravityOverride(0);
	m_hp = 5;
	m_delayBetweenAttacksMS = 1200;
	m_attackTimer = 0;
	m_nest = this:GetPos();
	m_naptime = true;
	this:GetBrainManager():Add("StandardBase","");
	this:GetBrainManager():SetStateByName("Idle");	
	this:SetCategory(C_CATEGORY_ENEMY, true);
	this:SetCategory(C_CATEGORY_ENTITY, false);
	this:SetCollisionCategory(C_CATEGORY_ENEMY, false);
	this:SetCollisionListenCategory(C_CATEGORY_ENEMY, false);
	this:SetCollisionListenCategory(C_CATEGORY_PLAYER, true);
	this:SetDensity(0.3);	
	Schedule(500+random(200), this:GetID(), "Think()");
	

	if (GameIsActive() == false) then
		this:GetBrainManager():SetStateByName("Frozen");
	end

end


function Think()

	if (m_hp <= 0) then
		--//we're dead, stop thinking!
		return;
	end
	
	if (m_naptime == true and this:IsCloseToEntity(GetPlayer, 320)) then	
		if ( this:HasLineOfSightToPosition(GetPlayer:GetPos(), true) ) then
			this:GetGoalManager():RemoveAllSubgoals();
			this:GetGoalManager():PushMoveToPosition(GetPlayer:GetPos());
			m_naptime = false;
		end			
	end
	
	if (m_naptime == false and this:IsCloseToEntity(GetPlayer, 512)) then	
		if ( this:HasLineOfSightToPosition(GetPlayer:GetPos(), true) ) then
			this:GetGoalManager():RemoveAllSubgoals();
			this:GetGoalManager():PushMoveToPosition(GetPlayer:GetPos());
			GetWatchManager:Add(this, 1000*10);
		else
			this:GetGoalManager():RemoveAllSubgoals();
			this:GetGoalManager():PushMoveToPosition(m_nest);
			GetWatchManager:Add(this, 1000*10);
			m_naptime = true;
		end			
	end	
	
	Schedule(300, this:GetID(), "Think()");

end




function OnAction(enemy)

	GetTextManager:Add("It's a bat.", enemy);
   
end

function SetParent(parent)

	m_parent = parent;
	
end

function OnDamage(normal, depth, enemy, damage, userVar, projectile)

	pushVec = this:GetPos() - enemy:GetPos();
	pushVec:Normalize();

	this:AddForce(pushVec * 15);
	
	if (m_hp <= 0) then
		return; --//already dead
	end


	m_hp = m_hp - damage;
	
	GetTextManager:AddCustom(tostring(damage), this, this:GetPos(), Vector2(0, -0.3), Color(200,0,0,255), 2000, C_FONT_DEFAULT);

	this:GetBrainManager():Add("ColorFlash", "pulse_rate=200;g=-200;b=-200;remove_brain_by_pulses=1");
 
	if (m_hp <= 0) then
		this:GetGoalManager():RemoveAllSubgoals();
	  	this:SetGravityOverride(C_GRAVITY_OVERRIDE_DISABLED);
		this:SetDensity(5);
		this:GetBrainManager():SetStateByName("Die");
	  	GetSoundManager:Play("audio/bug_die.ogg");
	  	Schedule(1000, this:GetID(), "this:GetBrainManager():Add('FadeOutAndDelete','');");
		this:SetCollisionCategories(C_CATEGORIES_NONE);
		this:SetPersistent(false);
		m_parent:Data():Set("BatHasSpawned", "false");
	else
		GetSoundManager:Play("audio/bug_attack.ogg");
	end
  
end


function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	if (m_hp > 0) then	
		if (m_attackTimer < GetApp:GetGameTick()) then
			entity:RunFunctionIfExists("OnDamage", vNormal, depth, entity, 5, 0, nil);
			pushVec = this:GetPos() - entity:GetPos();
			pushVec:Normalize();
			this:AddForce(pushVec * 10);
			m_attackTimer = GetApp:GetGameTick() + m_delayBetweenAttacksMS;
		end		
	end

	return true;
end

