function OnInit()

	this:SetVisualProfile("~/skeleton.xml", "skeleton");
	this:LoadCollisionInfo("~/skeleton.col");
	this:SetDensity(0.3);
	m_speechTimer = 0;
	bInitted = false;
	m_followID = C_ENTITY_NONE;
	m_walkSpeed = 5;
	this:SetDesiredSpeed(m_walkSpeed);
	this:SetTurnSpeed(10);
end

function OnPostInit()
	
	this:GetBrainManager():Add("StandardBase","");
	this:GetBrainManager():SendToBrainBase("control_filtery=0");
	this:GetBrainManager():SetStateByName("Idle");
	this:SetFacingTarget(C_FACING_LEFT);
	this:SetCategory(C_CATEGORY_ENEMY, true);
	this:SetCategory(C_CATEGORY_ENTITY, false);
	this:SetCollisionListenCategory(C_CATEGORY_PLAYER, true);
	m_hp = 100;

end

function OnAttackLoop()
	this:GetBrainManager():SetStateByName("Idle");
end


function OnIdleLoop()

	if (this:GetGoalManager():GetGoalCount() > 0) then
		return;
	end
	Schedule(100+random(100), this:GetID(), "Think()");
	
end

function Think()

	if (m_hp == 0) then
		--//we're dead, stop thinking!
		return;
	end
	
	if (this:IsCloseToEntity(GetPlayer, 80)) then
		
		this:GetGoalManager():RemoveAllSubgoals();
		this:SetVectorFacingTarget(this:GetVectorToEntity(GetPlayer));
		this:GetBrainManager():SetStateByName("Attack");
		GetSoundManager:Play("audio/effects/swing.ogg");
		Schedule(500, this:GetID(), 'ent = CreateEntity(this:GetMap(), this:GetPos(), "weapons/top_damage/top_damage.lua"); ent:RunFunction("SetParent", this); ent:RunFunction("SetStrength", 15);');
		
	elseif (this:IsCloseToEntity(GetPlayer, 512)) then
	
		this:GetGoalManager():RemoveAllSubgoals();
		this:GetGoalManager():PushMoveToPosition(GetPlayer:GetPos());
	
	end


end


function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	if (m_hp > 0) then
		entity:RunFunctionIfExists("OnDamage", vNormal, depth, entity, 5, 0, nil);
	end
  
	return;
end

function OnDamage(normal, depth, enemy, damage, userVar, projectile)

	pushVec = this:GetPos() - enemy:GetPos();
	pushVec:Normalize();

	this:AddForce(pushVec * 10);
	
	 if (m_hp <= 0) then
	 	--//already dead
	 	return;
 	end

	m_hp = m_hp - damage;
	GetTextManager:AddCustom(tostring(damage), this, this:GetPos(), Vector2(0, -0.3), Color(200,0,0,255), 2000, C_FONT_DEFAULT);
	this:GetBrainManager():Add("ColorFlash", "pulse_rate=200;g=-200;b=-200;remove_brain_by_pulses=1");
 
	if (m_hp <= 0) then
  --//kill it
	  	this:GetBrainManager():SetStateByName("Die");
	  	GetSoundManager:Play("audio/bug_die.ogg");
	  	Schedule(500, this:GetID(), "this:GetBrainManager():Add('FadeOutAndDelete','');");
		entCoin = CreateEntity(this:GetMap(), this:GetPos()+Vector2(0,-32), "items/coin/coin.lua");
		this:SetCollisionCategory(C_CATEGORY_PLAYER, false);
		this:SetLayerID(this:GetLayerID()-1);
		
		local gate2 = GetEntityByName("Boss1Gate2");
		gate2:RunFunction("OpenSesame");
		local gate1 = GetEntityByName("Boss1Gate1");
		gate1:RunFunction("OpenSesame");
		
	else
		GetSoundManager:Play("audio/bug_attack.ogg");
	end

end  
