function OnInit()

	this:SetVisualProfile("~/skeleton.xml", "skeleton");
	this:LoadCollisionInfo("~/skeleton.col");
	this:SetDensity(0);
	m_speechTimer = 0;
	bInitted = false;
	m_followID = C_ENTITY_NONE;
	m_walkSpeed = 5;
	this:SetDesiredSpeed(m_walkSpeed);
	this:SetTurnSpeed(10);
end

function OnPostInit()
	
	this:GetBrainManager():Add("StandardBase","");
	this:GetBrainManager():SendToBrainBase("control_filtery=0");
	this:GetBrainManager():SetStateByName("Special1");
	this:SetFacingTarget(C_FACING_LEFT);
	this:SetCategory(C_CATEGORY_ENEMY, true);
	this:SetCategory(C_CATEGORY_ENTITY, false);
	this:SetCollisionCategory(C_CATEGORY_PLAYER, false);
	this:SetCollisionListenCategory(C_CATEGORY_PLAYER, false);
	this:SetIsCreature(true);
	m_hp = 40;
	

end

function OnAttackLoop()
	this:GetBrainManager():SetStateByName("Idle");
	Schedule(100+random(80), this:GetID(), "Think()");
end

function ActivateIfNeeded()

	Schedule(1, this:GetID(), "Think()");
	this:GetBrainManager():SetStateByName("Idle");
	this:SetDensity(0.3);
	this:SetCategory(C_CATEGORY_ENEMY, true);
	this:SetCollisionCategory(C_CATEGORY_PLAYER, true);
	this:SetCollisionListenCategory(C_CATEGORY_PLAYER, true);

end


function Think()

	if (m_hp <= 0) then
		--//we're dead, stop thinking!
		return;
	end
	
	if (this:GetGoalManager():GetGoalCount() > 0) then
		Schedule(100, this:GetID(), "Think()");
		return;
	end
	
	if (CanAttack()) then return; end;
	
	if (math.random(2) == 1) then
		
		if GetPlayer != nil then
			v = GetPlayer:GetPos()-this:GetPos();
			v:Normalize();
			this:SetVectorFacingTarget(v);
		else
			this:SetFacingTarget(math.random(C_FACING_COUNT)-1);
		end
		
		this:GetBrainManager():SetStateByName("Walk");
		Schedule(200+random(300), this:GetID(), "Think()");
		
	else
		
		this:GetBrainManager():SetStateByName("Idle");
		Schedule(200+random(100), this:GetID(), "Think()");
		
	end

end

function CanAttack()

	if (this:IsCloseToEntity(GetPlayer, 80)) then		
		--this:GetGoalManager():RemoveAllSubgoals();
		this:SetVectorFacingTarget(this:GetVectorToEntity(GetPlayer));
		this:GetBrainManager():SetStateByName("Attack");
		GetSoundManager:Play("audio/effects/swing.ogg");
		Schedule(500, this:GetID(), 'ent = CreateEntity(this:GetMap(), this:GetPos(), "weapons/top_damage/top_damage.lua"); ent:RunFunction("SetParent", this); ent:RunFunction("SetStrength", 15);');
		return true;
	end
	return false;
end


function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	if (m_hp > 0) then
		entity:RunFunctionIfExists("OnDamage", vNormal, depth, entity, 5, 0, nil);
	end
  
	return;
end

function OnDamage(normal, depth, enemy, damage, userVar, projectile)

	pushVec = this:GetPos() - enemy:GetPos();
	pushVec:Normalize();

	this:AddForce(pushVec * 6);
	
	 if (m_hp <= 0) then
	 	--//already dead
	 	return;
 	end

	m_hp = m_hp - damage;
	GetTextManager:AddCustom(tostring(damage), this, this:GetPos(), Vector2(0, -0.3), Color(200,0,0,255), 2000, C_FONT_DEFAULT);
	this:GetBrainManager():Add("ColorFlash", "pulse_rate=200;g=-200;b=-200;remove_brain_by_pulses=1");
 
	if (m_hp <= 0) then
  --//kill it
	  	this:GetBrainManager():SetStateByName("Die");
	  	GetSoundManager:Play("audio/bug_die.ogg");
	  	Schedule(500, this:GetID(), "this:GetBrainManager():Add('FadeOutAndDelete','');");
		entCoin = CreateEntity(this:GetMap(), this:GetPos()+Vector2(0,-256), "spells/spark/spark_item.lua");
		this:SetCollisionCategory(C_CATEGORY_PLAYER, false);
		this:SetLayerID(this:GetLayerID()-1);
		
		local gate2 = GetEntityByName("Boss1Gate2");
		gate2:RunFunction("OpenSesame");
		local gate1 = GetEntityByName("Boss1Gate1");
		gate1:RunFunction("OpenSesame");
		
	else
		GetSoundManager:Play("audio/bug_attack.ogg");
	end

end

function ResetMe()

	GetWatchManager:Add(this, 1000*20);
	this:GetGoalManager():RemoveAllSubgoals();
	this:GetGoalManager():PushNewGoal("WaitForRematch");
	this:GetGoalManager():PushApproach(GetEntityIDByName("target_templateHA"), C_DISTANCE_TALK);
	m_hp = 60;
	
	local gate1 = GetEntityByName("Boss1Gate1");
	gate1:RunFunction("OpenSesame");
	ent = CreateEntity(this:GetMap(), this:GetPos()+Vector2(0,-16), "/enemies/skeleton/Boss1Rematch.lua");
	ent:SetLayerID(9);
	

end
