--//setup our item database, called from game_start.lua

--//The way items work is there is a global table variable of each kind of item that is referenced by name - this is for the info
--//that doesn't change.

--//A players "inventory" is a lua table that contains the name of each item he owns (the specifics of which can then be referenced
--//from the global g_Items table) plus it contains any 'per-instance' data that is needed, like how many blasts of the magic
--//wand are left.

g_Items = {};



--//add the items we need in the game to our global database, happens once at the start



g_Items.energy_drink = {name = "Energy Drink", desc = "Restores 10 MP", value=5, action = "Drink", power=10, group="items"};
g_Items.ice_cream = {name = "Ice Cream", desc = "Restores 10 HP", value=5, action = "Eat", power=10, group="items"};

--//element key: 0= none, 1=fire, 2=lightning, 3=ice

g_Items.short_sword = {name = "Short Sword", desc = "Damage 5", value=50, action = "Equip", power=5, group="weapons", element=0, range=40};
g_Items.firesword = {name = "Fire Sword", desc = "Damage 10", value=90, action = "Equip", power=10, group="weapons", element=1, range=45};

g_Items.spark = {name = "Spark", desc = "A simple electrical spell.", value=90, action = "Equip", power=5, group="magic"};

--//some general functions to make dealing with items easier

function AddItem(itemName, inventory)

	--//push to the front
	table.insert(inventory, 1, {item = itemName});
	--//Dump(inventory);
end

function RemoveItemByIndex(inventory, indexID)
	table.remove(inventory, indexID);
end

--//special handing for items that do stuff

function eatme(playerItem, playerItemPower)

	GetSoundManager:Play("audio/effects/gulp.ogg");
	GetPlayer:RunFunction("OnHeal", playerItemPower);
	return "return_to_menu";
end

function drinkme(playerItem, playerItemPower)

	GetSoundManager:Play("audio/effects/gulp.ogg");
	GetPlayer:RunFunction("OnRecharge", playerItemPower);
	return "return_to_menu";
end

function equipme(playerItem, playerItemPower)

	local itemDB = g_Items[playerItem];

	GetPlayer:RunFunction("OnEquip", playerItem, itemDB.power, itemDB.element, itemDB.range);
	GetSoundManager:Play("audio/effects/swordraw.ogg");
	return "return_to_menu";

end

function equipspell(playerItem, playerItemPower)

	GetPlayer:RunFunction("SpellEquip", playerItem, playerItemPower);
	GetSoundManager:Play("audio/effects/swordraw.ogg");
	return "return_to_menu";

end
