function OnInit()
	
	this:SetVisualProfile("~/spark.xml", "spell");
	this:LoadCollisionInfo("~/spark.col");
	this:SetPersistent(false); --//don't bother saving this
	m_parent = nil;
	m_canHit = false;
	this:SetDensity(1);
	this:SetBlendMode(C_BLEND_MODE_ADDITIVE);
	--this:SetBaseColor(Color(255,255,255,150));
	this:SetCollisionCategories(C_CATEGORIES_NONE);
	this:SetGravityOverride(0);
	this:SetDesiredSpeed(10);
	--this:SetAcceleration(10);
	
end

function OnPostInit()

	Schedule(2500, this:GetID(), "this:SetDeleteFlag(true);");
	--SetupParticleSystem();
	if (GetPlayer != nil) then
		this:SetLayerID(GetPlayer:GetLayerID()+1);
	end

end

function OnKill()


end

function SetParent(parent)
	m_parent = parent;
	this:SetFacing(parent:GetFacing());
	GetSoundManager:Play("audio/effects/coin.ogg");
	this:SetSpriteByVisualStateAndFacing();
	this:GetBrainManager():Add("StandardBase", "");
	this:GetBrainManager():SetStateByName("Walk");
	this:SetCollisionListenCategory(C_CATEGORY_ENTITY, false);
	this:SetCollisionListenCategory(C_CATEGORY_ENEMY, true);
	Schedule(1, this:GetID(), "m_canHit = true;");
end

function OnAction(enemy)

end


function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	if (m_canHit == false or entity == nil) then
	  return;
	end
	
	if (entity:GetID() == m_parent:GetID()) then
		
	else
		
  		entity:RunFunctionIfExists("OnDamage", vNormal, depth, m_parent, 6, 2, this);
	end
	
		Schedule(1, this:GetID(), "m_canHit = false;");
		this:GetBrainManager():Add("FadeOutAndDelete", "fade_speed_ms=100");

	return; --//don't allow collision to happen

end

function SetupParticleSystem()

	--//setup a particle system of blue trailing sparkles
	
	local particle = GetEffectManager:GetParticleByName("simple");
	
	if (not particle) then
		--//this means we need to create it, only happens once during the game - if you
		--//change these settings, you will need to restart the engine! Or, make changes
		--//to the existing "simple", it will modify all instances using it on the fly
		particle = GetEffectManager:CreateParticle("simple", "effects/media/small.png", 1000);
		particle:SetColor(Color(50,62,155,255));
		particle:SetColoring1(Color(0,80,100,0), 0.8);
		particle:GetMotionController():Set1DAcceleration(-0.0003);
		particle:GetMotionController():SetMaxSpeed(0.1);
		
	end
	
	m_pEffectExplosion = GetEffectManager:CreateEffectExplosion(16,10,12,0.1);
	m_pEffectExplosion:AddParticle(particle, C_PROBABILITY_DEFAULT);
	m_pEffectExplosion:SetLifeDistortion(700);
	
	this:AddEffect(m_pEffectExplosion);

end


